#ifndef __XMLPARSER_H
#define __XMLPARSER_H

#include <qstring.h>
#include <qxml.h>
#include <qlist.h>
class XmlParser :public QXmlDefaultHandler
{
public:
  class Key
  {
  public:
    Key( int keycode, int state );
    int key() const;
    int state() const;
  private:
    int _keycode, _state;
  };

  typedef QList<Key> KeyList;
  typedef QListIterator<Key> KeyListIterator;
  
  class KeyConfig 
  {
  public:
    KeyConfig();
    void addKey( Key* );
    void setReplacement( const QString& txt );
    KeyList& items();
    QString replacement() const;
  private:
    KeyList _items;
    QString _replacement;
  };

  typedef QList<KeyConfig> KeyConfigList;
  typedef QListIterator<KeyConfig> KeyConfigListIterator;

  class Keyboard
  {
  public:
    Keyboard();
    void addKeyConfig( KeyConfig* );
    KeyConfigList& items();
  private:
    KeyConfigList _items;
  }; 

  XmlParser() {}
  Keyboard* parse( const QString& fileName );
  bool startElement( const QString&, const QString&, const QString& qName,
                     const QXmlAttributes& );
    
private:
  Keyboard* _keyboard;
  KeyConfig* _keyConfig;
};


#endif // __XMLPARSER_H
