#ifndef __INPUTBUTTON_H
#define __INPUTBUTTON_H

#include <qpushbutton.h>
class QKeyEvent;

class InputButton :public QPushButton
{
Q_OBJECT
public:
  InputButton( QWidget* parent, const char* name = 0 );
  InputButton( int keycode, int state, QWidget* parent, const char* name = 0 );
  int key() const;
  int state() const;
  bool changed() const;

protected:
  void keyPressEvent( QKeyEvent* );
  void setText( int keycode, int state );

protected slots:
  void takeFocus();

private:
  bool _changed;
  int _key;
  int _state;
};

#endif // __INPUTBUTTON_H
