#ifndef __KEYCONFIG_H
#define __KEYCONFIG_H
#include <qwidget.h>
#include <qlist.h>
#include "inputbutton.h"
#include <qlineedit.h>
#include "xmlparser.h"
class QHBoxLayout;
class QFrame;

class KeyConfig :public QWidget
{
Q_OBJECT

public:
  KeyConfig( QWidget* parent, const char* name = 0 );
  KeyConfig( const XmlParser::KeyList& keys, QWidget* parent, const char* name = 0 );
  QString xml() const;
  void setReplacement( const QString& replacement );

protected slots:
  void addButton();
  void del();

protected:
  void setup();

signals:
  void deleteMe( KeyConfig* );

private:
  QHBoxLayout* _layout;
  QList<InputButton> _items;
  QLineEdit* _edit;
  QFrame* _line;
};

#endif __KEYCONFIG_H
