#ifndef __KEYCONFIGSET_H
#define __KEYCONFIGSET_H
#include <qwidget.h>
#include <qlist.h>
#include "keyconfig.h"
#include "xmlparser.h"
class QVBoxLayout;
class QScrollView;

class KeyConfigSet :public QWidget
{
Q_OBJECT
public:
  KeyConfigSet( QWidget* parent, const char* name = 0 );
  KeyConfigSet( const XmlParser::KeyConfigList& keyList, QWidget* parent, const char* name = 0 );
  QString xml() const;
  
protected slots:
  void add();
  void del( KeyConfig* conf );
  void forceRepaint();

protected:
  void setup();
  void add( const QString& replacement, const XmlParser::KeyList& keys );
  void add( KeyConfig* config );

private:
  QWidget* _top;
  QVBoxLayout* _layout;
  QList<KeyConfig> _items;
  QScrollView* _view;
};


#endif // __KEYCONFIGSET_H
