#ifndef __inputwidget
#define __inputwidget
#include <qwidget.h>
#include <qsize.h>
#include <qstringlist.h>
#include <qrect.h>
#include <qpixmap.h>
#include <qcstring.h>
class QPaintEvent;
class QMouseEvent;

class InputWidget :public QWidget
{
Q_OBJECT
public:
  InputWidget( QWidget* parent, const char* name = 0, WFlags f = 0 );
signals:
  void key(ushort,ushort,ushort,bool,bool);

protected:
  virtual void paintEvent( QPaintEvent* event );
  virtual QSize sizeHint() const;
  virtual void mousePressEvent( QMouseEvent* event );
  virtual void mouseReleaseEvent( QMouseEvent* event );
  void paint( bool force, bool reload ) const;
  void reread();
  
protected slots:
  void message( const QCString& );

private:
  QString _symbols;
  int _fontSize;
  mutable QValueList<QRect> _regions;
  mutable QPixmap _buffer;
  mutable int _width;
  int _selected;
};


#endif /* inputwidget */

